       IDENTIFICATION DIVISION.
       PROGRAM-ID.    CBLRTNC1.
       AUTHOR.        SIMOTIME TECHNOLOGIES.
      *****************************************************************
      * Copyright (C) 1987-2019 SimoTime Technologies.                *
      *                                                               *
      * All rights reserved.  Unpublished, all rights reserved under  *
      * copyright law and international treaty.  Use of a copyright   *
      * notice is precautionary only and does not imply publication   *
      * or disclosure.                                                *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any non-commercial purpose and without fee is hereby      *
      * granted, provided the SimoTime copyright notice appear on all *
      * copies of the software. The SimoTime name or Logo may not be  *
      * used in any advertising or publicity pertaining to the use    *
      * of the software without the written permission of SimoTime    *
      * Technologies.                                                 *
      *                                                               *
      * Permission to use, copy, modify and distribute this software  *
      * for any commercial purpose requires a fee to be paid to       *
      * SimoTime Technologies. Once the fee is received by SimoTime   *
      * the latest version of the software will be delivered and a    *
      * license will be granted for use within an enterprise,         *
      * provided the SimoTime copyright notice appear on all copies   *
      * of the software. The SimoTime name or Logo may not be used    *
      * in any advertising or publicity pertaining to the use of the  *
      * software without the written permission of SimoTime           *
      * Technologies.                                                 *
      *                                                               *
      * SimoTime Technologies makes no warranty or representations    *
      * about the suitability of the software for any purpose. It is  *
      * provided "AS IS" without any expressed or implied warranty,   *
      * including the implied warranties of merchantability, fitness  *
      * for a particular purpose and non-infringement. SimoTime       *
      * Technologies shall not be liable for any direct, indirect,    *
      * special or consequential damages resulting from the loss of   *
      * use, data or projects, whether in an action of contract or    *
      * tort, arising out of or in connection with the use or         *
      * performance of this software                                  *
      *                                                               *
      * SimoTime Technologies                                         *
      * 15 Carnoustie Drive                                           *
      * Novato, CA 94949-5849                                         *
      * 415.883.6565                                                  *
      *                                                               *
      * RESTRICTED RIGHTS LEGEND                                      *
      * Use, duplication, or disclosure by the Government is subject  *
      * to restrictions as set forth in subparagraph (c)(1)(ii) of    *
      * the Rights in Technical Data and Computer Software clause at  *
      * DFARS 52.227-7013 or subparagraphs (c)(1) and (2) of          *
      * Commercial  Computer Software - Restricted Rights  at 48      *
      * CFR 52.227-19, as applicable.  Contact SimoTime Technologies, *
      * 15 Carnoustie Drive, Novato, CA 94949-5849.                   *
      *                                                               *
      *****************************************************************
      *      This program is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *                                                               *
      *****************************************************************
      *
      *****************************************************************
      * Source Member: CBLRTNC1.CBL
      * Copy Files:    PASSSTAT.CPY
      *****************************************************************
      *
      * CBLRTNC1 - Format, describe and display File Status code.
      *
      * CALLING PROTOCOL
      * ----------------
      * Use standard procedure to RUN or ANIMATE.
      *
      * DESCRIPTION
      * -----------
      * This program provides an example of how to format, describe
      * and display the File Status Code.
      *
      *          ************
      *          * CBLREPJ1 *
      *          ********jcl*
      *               *
      *               *
      *          ************     ************
      *          * CBLRTNC1 *-----* CONSOLE  *
      *          ********cbl*     ******dsply*
      *               *
      *               *
      *          ************
      *          * SIMOSTAT *
      *          ********cbl*
      *
      *****************************************************************
      *
      * MAINTENANCE
      * -----------
      * 1987/05/22 Simmons, Created program.
      * 1994/04/17 Simmons, Updated for PC.
      *
      *****************************************************************
      *
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
           SELECT TESTFILE-FILE
                  ASSIGN       to TESTFILE
                  ORGANIZATION is SEQUENTIAL
                  ACCESS MODE  is SEQUENTIAL
                  FILE STATUS  is TESTFILE-STATUS.
      *
       DATA DIVISION.
       FILE SECTION.
       FD  TESTFILE-FILE.
       01  TESTFILE-RECORD.
           05  TESTFILE-ID        pic X(6).
           05  TESTFILE-DATA      pic X(74).

       WORKING-STORAGE SECTION.
      *****************************************************************
      *    Data-structure for Title and Copyright...
      *    ------------------------------------------------------------
       01  SIM-TITLE.
           05  T1 pic X(11) value '* CBLRTNC1 '.
           05  T2 pic X(34) value 'File Status Demonstration         '.
           05  T3 pic X(10) value ' v03.01.24'.
           05  T4 pic X(24) value ' http://www.simotime.com'.
       01  SIM-COPYRIGHT.
           05  C1 pic X(11) value '* CBLRTNC1 '.
           05  C2 pic X(20) value 'Copyright 1987-2019 '.
           05  C3 pic X(28) value '   SimoTime Technologies    '.
           05  C4 pic X(20) value ' All Rights Reserved'.

       01  SIM-THANKS-01.
           05  C1 pic X(11) value '* CBLRTNC1 '.
           05  C2 pic X(32) value 'Thank you for using this program'.
           05  C3 pic X(32) value ' provided from SimoTime Technolo'.
           05  C4 pic X(04) value 'gies'.

       01  SIM-THANKS-02.
           05  C1 pic X(11) value '* CBLRTNC1 '.
           05  C2 pic X(32) value 'Please send all inquires or sugg'.
           05  C3 pic X(32) value 'estions to the helpdesk@simotime'.
           05  C4 pic X(04) value '.com'.

      *****************************************************************
       01  TESTFILE-STATUS.
           05  TESTFILE-STAT1      pic X.
           05  TESTFILE-STAT2      pic X.

      *****************************************************************
      * Message Buffer used by the Z-DISPLAY-MSG-72-TEXT routine.    *
      *****************************************************************
       01  MESSAGE-BUFFER-72.
           05  MSG-72-HEADER       pic X(11)   value '* CBLRTNC1 '.
           05  MSG-72-TEXT         pic X(61)   value SPACES.

       01  MESSAGE-BUFFER-FOR-STATUS.
           05  filler      pic X(11) value '* CBLRTNC1 '.
           05  filler      pic X(2)  value SPACES.
           05  IO-STAT-02  pic X(2)  value SPACES.
           05  filler      pic X(2)  value ', '.
           05  filler      pic X(25) value 'Two-Byte File Status Code'.

      *****************************************************************
       COPY PASSSTAT.

      *****************************************************************
       PROCEDURE DIVISION.

           perform Z-POST-COPYRIGHT

           perform Z-DISPLAY-MSG-72-TEXT
           move '****  Pre-planned I/O failures...' to MSG-72-TEXT
           perform Z-DISPLAY-MSG-72-TEXT
           perform PREPLANNED-IO-FAILURES

           perform Z-DISPLAY-MSG-72-TEXT
           move '****  Random File Status Codes...' to MSG-72-TEXT
           perform Z-DISPLAY-MSG-72-TEXT
           perform STATUS-CODES-RANDOM-SAMPLE

           perform Z-DISPLAY-MSG-72-TEXT
           perform Z-THANK-YOU.

           GOBACK.

      *****************************************************************
       PREPLANNED-IO-FAILURES.
      *>   Try a READ before an OPEN...
           read TESTFILE-FILE.
           move TESTFILE-STATUS to FSPA-STATUS-CODE-02
           call 'SIMOSTAT' using FILE-STATUS-PASS-AREA
           move FSPA-TEXT-MESSAGE to MSG-72-TEXT
           perform Z-DISPLAY-MSG-72-TEXT

      *>   Try an OPEN for INPUT with a non-existing file...
           open input TESTFILE-FILE.
           move TESTFILE-STATUS to FSPA-STATUS-CODE-02
           call 'SIMOSTAT' using FILE-STATUS-PASS-AREA
           move FSPA-TEXT-MESSAGE to MSG-72-TEXT
           perform Z-DISPLAY-MSG-72-TEXT

      *>   Try a CLOSE for a non-existing, non-OPENed file...
           close TESTFILE-FILE.
           move TESTFILE-STATUS to FSPA-STATUS-CODE-02
           call 'SIMOSTAT' using FILE-STATUS-PASS-AREA
           move FSPA-TEXT-MESSAGE to MSG-72-TEXT
           perform Z-DISPLAY-MSG-72-TEXT
           exit.

      *>   Try a REWRITE just for grins...
           rewrite TESTFILE-RECORD
           move TESTFILE-STATUS to FSPA-STATUS-CODE-02
           call 'SIMOSTAT' using FILE-STATUS-PASS-AREA
           move FSPA-TEXT-MESSAGE to MSG-72-TEXT
           perform Z-DISPLAY-MSG-72-TEXT

      *>   Try a WRITE and display status on non-zero condition...
           write TESTFILE-RECORD
           if  TESTFILE-STATUS not = '00'
               move  TESTFILE-STATUS to FSPA-STATUS-CODE-02
               call 'SIMOSTAT' using FILE-STATUS-PASS-AREA
               move FSPA-TEXT-MESSAGE to MSG-72-TEXT
               perform Z-DISPLAY-MSG-72-TEXT
           end-if
           exit.

      *****************************************************************
       STATUS-CODES-RANDOM-SAMPLE.
      *>   Example 1, Create/Display a Two-Byte, Primary Status Code
           move '00' to IO-STAT-02
           display MESSAGE-BUFFER-FOR-STATUS upon console
      *    Create/Display four-byte code and description...
           move IO-STAT-02 to FSPA-STATUS-CODE-02
           call 'SIMOSTAT' using FILE-STATUS-PASS-AREA
           move FSPA-TEXT-MESSAGE to MSG-72-TEXT
           perform Z-DISPLAY-MSG-72-TEXT

      *>   Example 2, Create/Display a Two-Byte, Primary Status Code
           move '35' to IO-STAT-02
           display MESSAGE-BUFFER-FOR-STATUS upon console
      *    Create/Display four-byte code and description...
           move IO-STAT-02 to FSPA-STATUS-CODE-02
           call 'SIMOSTAT' using FILE-STATUS-PASS-AREA
           move FSPA-TEXT-MESSAGE to MSG-72-TEXT
           perform Z-DISPLAY-MSG-72-TEXT

      *>   Example 3, Create/Display a Two-Byte, Extended Status Code
           move '9'   to IO-STAT-02(1:1)
           move x'7D' to IO-STAT-02(2:1)
           display MESSAGE-BUFFER-FOR-STATUS upon console
      *    Create/Display four-byte code and description...
           move IO-STAT-02 to FSPA-STATUS-CODE-02
           call 'SIMOSTAT' using FILE-STATUS-PASS-AREA
           move FSPA-TEXT-MESSAGE to MSG-72-TEXT
           perform Z-DISPLAY-MSG-72-TEXT

      *>   Example 4, Create/Display a Two-Byte, Primary Status Code
           move '41' to IO-STAT-02
           display MESSAGE-BUFFER-FOR-STATUS upon console
      *    Create/Display four-byte code and description...
           move IO-STAT-02 to FSPA-STATUS-CODE-02
           call 'SIMOSTAT' using FILE-STATUS-PASS-AREA
           move FSPA-TEXT-MESSAGE to MSG-72-TEXT
           perform Z-DISPLAY-MSG-72-TEXT

      *>   Example 5, Create/Display a Two-Byte, Extended Status Code
           move '9'   to IO-STAT-02(1:1)
           move x'DB' to IO-STAT-02(2:1)
           display MESSAGE-BUFFER-FOR-STATUS upon console
      *    Create/Display four-byte code and description...
           move IO-STAT-02 to FSPA-STATUS-CODE-02
           call 'SIMOSTAT' using FILE-STATUS-PASS-AREA
           move FSPA-TEXT-MESSAGE to MSG-72-TEXT
           perform Z-DISPLAY-MSG-72-TEXT

           exit.

      *****************************************************************
      * The following Z-Routines perform administrative tasks         *
      * for this program.                                             *
      *****************************************************************

      *****************************************************************
       Z-POST-COPYRIGHT.
           display SIM-TITLE upon console
           display SIM-COPYRIGHT upon console
           exit.

      *****************************************************************
      * Display CONSOLE messages...                                   *
      *****************************************************************
       Z-DISPLAY-MSG-72-TEXT.
           display MESSAGE-BUFFER-72 upon console
           move all SPACES to MSG-72-TEXT
           exit.

      *****************************************************************
       Z-THANK-YOU.
           display SIM-THANKS-01 upon console
           display SIM-THANKS-02 upon console
           exit.

      *****************************************************************
      *      This example is provided by SimoTime Technologies        *
      *        Our e-mail address is: helpdesk@simotime.com           *
      *     Also, visit our Web Site at http://www.simotime.com       *
      *****************************************************************
